////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/// 
///  Copyright 2009 Aurora Feint, Inc.
/// 
///  Licensed under the Apache License, Version 2.0 (the "License");
///  you may not use this file except in compliance with the License.
///  You may obtain a copy of the License at
///  
///  	http://www.apache.org/licenses/LICENSE-2.0
///  	
///  Unless required by applicable law or agreed to in writing, software
///  distributed under the License is distributed on an "AS IS" BASIS,
///  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
///  See the License for the specific language governing permissions and
///  limitations under the License.
/// 
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#import "OFNotificationStatus.h"
@class MPOAuthAPIRequestLoader;
@class OFNotificationInputResponse;
@class OFAchievement;
@class OFChallengeToUser;
@class OFNotificationData;
@class OFServerNotification;

@interface OFNotification : NSObject
{
	OFNotificationData* defaultBackgroundNotice;
	OFNotificationStatus* defaultStatus;
	OFNotificationInputResponse* defaultInputResponse;
}

@property (nonatomic, retain) OFNotificationData* defaultBackgroundNotice;
@property (nonatomic, retain) OFNotificationStatus* defaultStatus;
@property (nonatomic, retain) OFNotificationInputResponse* defaultInputResponse;

+ (OFNotification*)sharedInstance;

- (void)showBackgroundNoticeForLoader:(MPOAuthAPIRequestLoader*)request withNotice:(OFNotificationData*)noticeData;
- (void)showBackgroundNotice:(OFNotificationData*)noticeData andStatus:(OFNotificationStatus*)status andInputResponse:(OFNotificationInputResponse*)inputResponse;
- (void)showAchievementNotice:(OFAchievement*)unlockedAchievement withInputResponse:(OFNotificationInputResponse*)inputResponse;
- (void)showChallengeNotice:(OFChallengeToUser*)challengeToUser withInputResponse:(OFNotificationInputResponse*)inputResponse;
- (void)showServerNotification:(OFServerNotification*)serverNotification;

- (void)setDefaultBackgroundNotice:(OFNotificationData*)noticeData andStatus:(OFNotificationStatus*)status andInputResponse:(OFNotificationInputResponse*)inputResponse;
- (void)showDefaultNotice;
- (void)clearDefaultNotice;


@end
